=== debian/changelog ===
pthreadpool (0.0~git20200423.6acde9c-2) unstable; urgency=medium

  * Add the missing build dependencies.
  * Apply wrap-and-sort.
  * Add symbols control file for libpthreadpool0.
  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Wed, 29 Apr 2020 08:54:40 +0800

pthreadpool (0.0~git20200423.6acde9c-1) experimental; urgency=medium

  * Initial release. (Closes: #958655)

 -- Mo Zhou <lumin@debian.org>  Fri, 24 Apr 2020 16:02:29 +0800
