=== debian/changelog ===
pthreadpool (0.0~git20200615.029c886-2) unstable; urgency=medium

  * Change maintainer into Deep Learning Team <debian-ai@l.d.o>.
  * Please pin to this upstream snapshot for PyTorch 1.7.0.

 -- Mo Zhou <lumin@debian.org>  Mon, 02 Nov 2020 11:03:57 +0800

pthreadpool (0.0~git20200615.029c886-1) unstable; urgency=medium

  * New upstream version 0.0~git20200615.029c886
  * Refresh symbols control file (+ several new symbols).
  * Bump debhelper compat level to 13.
  * Add d/not-installed.

 -- Mo Zhou <lumin@debian.org>  Wed, 02 Sep 2020 13:44:18 +0800
