=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
 Uploaders: Mo Zhou <lumin@debian.org>
 Build-Depends: cmake,
-               debhelper-compat (= 12),
+               debhelper-compat (= 13),
                googletest,
                libbenchmark-dev,
                libcpuinfo-dev,
