=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ -Scmake

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest -DPTHREADPOOL_LIBRARY_TYPE=shared
