## pthreadpool 0.0~git20201005.fa75e65

=== CMakeLists.txt ===
--- 
+++ 
@@ -123,9 +123,9 @@
   MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
 ENDIF()
 IF(PTHREADPOOL_ENABLE_FASTPATH)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=1)
-ELSE()
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_ENABLE_FASTPATH=0)
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=1)
+ELSE()
+  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=0)
 ENDIF()
 
 SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
@@ -178,6 +178,13 @@
     CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool pthreadpool-test)
+
+  ADD_EXECUTABLE(pthreadpool-cxx-test test/pthreadpool-cxx.cc)
+  SET_TARGET_PROPERTIES(pthreadpool-cxx-test PROPERTIES
+    CXX_STANDARD 11
+    CXX_EXTENSIONS NO)
+  TARGET_LINK_LIBRARIES(pthreadpool-cxx-test pthreadpool gtest gtest_main)
+  ADD_TEST(pthreadpool-cxx pthreadpool-cxx-test)
 ENDIF()
 
 IF(PTHREADPOOL_BUILD_BENCHMARKS)
