=== debian/changelog ===
pthreadpool (0.0~git20201005.fa75e65-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Thu, 02 Sep 2021 02:07:37 +0000

pthreadpool (0.0~git20201005.fa75e65-1) experimental; urgency=medium

  * New upstream version 0.0~git20201005.fa75e65
    Please pin to this snapshot for PyTorch/v1.8.1
  * Refresh existint patches.
  * Refresh symbols control file.

 -- Mo Zhou <lumin@debian.org>  Thu, 20 May 2021 11:43:45 +0800
