## pthreadpool 0.0~git20210507.1787867

=== debian/changelog ===
pthreadpool (0.0~git20210507.1787867-2) unstable; urgency=medium

  [ Debian Janitor ]
  * Apply multi-arch hints. + libpthreadpool0: Add Multi-Arch: same.

  [ Mo Zhou ]
  * Bump Standards-Version to 4.6.2 (no change).

 -- Mo Zhou <lumin@debian.org>  Fri, 01 Sep 2023 21:41:04 -0400

pthreadpool (0.0~git20210507.1787867-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sat, 25 Jun 2022 20:05:43 -0700

pthreadpool (0.0~git20210507.1787867-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20210507.1787867
    This snapshot should be fine for PyTorch/v1.12.X
  * Upload to experimental.

 -- Mo Zhou <lumin@debian.org>  Thu, 23 Jun 2022 22:44:16 -0700
