=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Homepage: https://github.com/Maratyszcza/pthreadpool
 Priority: optional
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -28,6 +28,7 @@
 Package: libpthreadpool0
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
+Multi-Arch: same
 Description: pthread-based thread pool for C/C++
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional
