=== debian/changelog ===
pthreadpool (0.0~git20240616.560c60d-1) unstable; urgency=medium

  * Team upload.
  * d/patches: refresh, rename and add DEP3 header
  * d/control: bump std-ver to 4.7.0.1 (no changes required)
  * d/rules: enable all hardening

 -- Shengqi Chen <harry-chen@outlook.com>  Wed, 04 Sep 2024 19:45:20 +0800

pthreadpool (0.0~git20240616.560c60d-1~exp1) experimental; urgency=medium

  * New upstream version 0.0~git20240616.560c60d
    + This snapshot should be fine for PyTorch/v2.3.X
  * Refresh symbols control file.
  * Make short description different for packages.
  * Upload to experimental
  * Upload to experimental

 -- Mo Zhou <harry-chen@outlook.com>  Wed, 04 Sep 2024 19:37:32 +0800
