=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libdevel
 Homepage: https://github.com/Maratyszcza/pthreadpool
 Priority: optional
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0.1
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -18,7 +18,7 @@
 Package: libpthreadpool-dev
 Architecture: any
 Depends: libpthreadpool0 (= ${binary:Version}), ${misc:Depends}
-Description: pthread-based thread pool for C/C++
+Description: pthread-based thread pool for C/C++ (development)
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional
  features.
@@ -29,7 +29,7 @@
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
-Description: pthread-based thread pool for C/C++
+Description: pthread-based thread pool for C/C++ (shared object)
  pthreadpool is a portable and efficient thread pool implementation. It provides
  similar functionality to #pragma omp parallel for, but with additional
  features.
