## pthreadpool 0.0~git20251020.0e6ca13

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,51 @@
+# Copyright (c) 2017 Facebook Inc.
+# Copyright (c) 2015-2017 Georgia Institute of Technology
+# All rights reserved.
+#
+# Copyright 2019 Google LLC
+#
+# This source code is licensed under the BSD-style license found in the
+# LICENSE file in the root directory of this source tree.
+
 CMAKE_MINIMUM_REQUIRED(VERSION 3.5 FATAL_ERROR)
 
 # ---[ Project
 PROJECT(pthreadpool C)
+
+# --[ Use ccache if available
+FIND_PROGRAM(CCACHE_BINARY "ccache")
+IF(CCACHE_BINARY)
+  MESSAGE(STATUS "Using ccache: ${CCACHE_BINARY}")
+  SET(CMAKE_CXX_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "CXX compiler launcher" FORCE)
+  SET(CMAKE_C_COMPILER_LAUNCHER "${CCACHE_BINARY}" CACHE STRING "C compiler launcher" FORCE)
+  IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO "${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_DEBUG_INIT "${CMAKE_C_FLAGS_DEBU_INITG}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_DEBUG_INIT "${CMAKE_CXX_FLAGS_DEBUG_INIT}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_C_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_C_FLAGS_RELWITHDEBINFO_INIT}")
+    STRING(REPLACE "/Zi" "/Z7" CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT "${CMAKE_CXX_FLAGS_RELWITHDEBINFO_INIT}")
+  ENDIF()
+ENDIF()
+
+# ---[ Language options.
+SET(CMAKE_C_STANDARD 11)
+SET(CMAKE_C_EXTENSIONS NO)
+SET(CMAKE_CXX_STANDARD 11)
+SET(CMAKE_CXX_EXTENSIONS NO)
+IF(CMAKE_C_COMPILER_ID STREQUAL "MSVC")
+  STRING(APPEND CMAKE_C_FLAGS " /experimental:c11atomics")
+  STRING(APPEND CMAKE_CXX_FLAGS " /experimental:c11atomics")
+ENDIF()
 
 # ---[ Options.
 SET(PTHREADPOOL_LIBRARY_TYPE "default" CACHE STRING "Type of library (shared, static, or default) to build")
 SET_PROPERTY(CACHE PTHREADPOOL_LIBRARY_TYPE PROPERTY STRINGS default static shared)
 OPTION(PTHREADPOOL_ALLOW_DEPRECATED_API "Enable deprecated API functions" ON)
-SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, gcd, event, or default) for worker threads")
-SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex gcd event)
+SET(PTHREADPOOL_SYNC_PRIMITIVE "default" CACHE STRING "Synchronization primitive (condvar, futex, or default) for worker threads")
+SET_PROPERTY(CACHE PTHREADPOOL_SYNC_PRIMITIVE PROPERTY STRINGS default condvar futex)
 IF(CMAKE_SYSTEM_PROCESSOR MATCHES "^(i[3-6]86|AMD64|x86(_64)?)$")
   OPTION(PTHREADPOOL_ENABLE_FASTPATH "Enable fast path using atomic decrement instead of atomic compare-and-swap" ON)
 ELSE()
@@ -32,12 +69,6 @@
 IF(PTHREADPOOL_BUILD_TESTS)
   ENABLE_TESTING()
 ENDIF()
-
-MACRO(PTHREADPOOL_TARGET_ENABLE_CXX11 target)
-  SET_TARGET_PROPERTIES(${target} PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
-ENDMACRO()
 
 # ---[ Download deps
 IF(NOT DEFINED FXDIV_SOURCE_DIR)
@@ -77,14 +108,7 @@
 IF(EMSCRIPTEN)
   LIST(APPEND PTHREADPOOL_SRCS src/shim.c)
 ELSE()
-  LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c)
-  IF(APPLE AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd"))
-    LIST(APPEND PTHREADPOOL_SRCS src/gcd.c)
-  ELSEIF(CMAKE_SYSTEM_NAME MATCHES "^(Windows|CYGWIN|MSYS)$" AND (PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default" OR PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event"))
-    LIST(APPEND PTHREADPOOL_SRCS src/windows.c)
-  ELSE()
-    LIST(APPEND PTHREADPOOL_SRCS src/pthreads.c)
-  ENDIF()
+  LIST(APPEND PTHREADPOOL_SRCS src/portable-api.c src/memory.c src/pthreads.c)
   IF(PTHREADPOOL_ENABLE_FASTPATH)
     LIST(APPEND PTHREADPOOL_SRCS src/fastpath.c)
   ENDIF()
@@ -110,19 +134,9 @@
 IF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "condvar")
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
 ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "futex")
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=1)
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
-ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "gcd")
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=1)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=0)
-ELSEIF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "event")
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FUTEX=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_GCD=0)
-  TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_EVENT=1)
 ELSEIF(NOT PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "default")
   MESSAGE(FATAL_ERROR "Unsupported synchronization primitive ${PTHREADPOOL_SYNC_PRIMITIVE}")
 ENDIF()
@@ -132,9 +146,6 @@
   TARGET_COMPILE_DEFINITIONS(pthreadpool PRIVATE PTHREADPOOL_USE_FASTPATH=0)
 ENDIF()
 
-SET_TARGET_PROPERTIES(pthreadpool PROPERTIES
-  C_STANDARD 11
-  C_EXTENSIONS NO)
 TARGET_LINK_LIBRARIES(pthreadpool PUBLIC pthreadpool_interface)
 TARGET_INCLUDE_DIRECTORIES(pthreadpool PRIVATE src)
 IF(NOT CMAKE_SYSTEM_NAME STREQUAL "Emscripten")
@@ -177,16 +188,17 @@
   ENDIF()
 
   ADD_EXECUTABLE(pthreadpool-test test/pthreadpool.cc)
-  SET_TARGET_PROPERTIES(pthreadpool-test PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool pthreadpool-test)
 
+  IF(PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "condvar" OR
+     PTHREADPOOL_SYNC_PRIMITIVE STREQUAL "futex")
+    ADD_EXECUTABLE(pthreadpool-v2-test test/pthreadpool_v2.cc)
+    TARGET_LINK_LIBRARIES(pthreadpool-v2-test pthreadpool gtest gtest_main)
+    ADD_TEST(pthreadpool pthreadpool-v2-test)
+  ENDIF()
+
   ADD_EXECUTABLE(pthreadpool-cxx-test test/pthreadpool-cxx.cc)
-  SET_TARGET_PROPERTIES(pthreadpool-cxx-test PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(pthreadpool-cxx-test pthreadpool gtest gtest_main)
   ADD_TEST(pthreadpool-cxx pthreadpool-cxx-test)
 ENDIF()
@@ -201,14 +213,8 @@
   ENDIF()
 
   ADD_EXECUTABLE(latency-bench bench/latency.cc)
-  SET_TARGET_PROPERTIES(latency-bench PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(latency-bench pthreadpool benchmark)
 
   ADD_EXECUTABLE(throughput-bench bench/throughput.cc)
-  SET_TARGET_PROPERTIES(throughput-bench PROPERTIES
-    CXX_STANDARD 11
-    CXX_EXTENSIONS NO)
   TARGET_LINK_LIBRARIES(throughput-bench pthreadpool benchmark)
 ENDIF()
