=== debian/changelog ===
pthreadpool (0.0~git20251020.0e6ca13-1) unstable; urgency=medium

  * Team upload.
  * d/watch: switch to version 5, use Google fork as upstream.
  * New upstream version 0.0~git20251020.0e6ca13.
  * d/copyright: update with latest author info.
  * d/patches: refresh existing patches.
  * d/symbols: add new symbols for libpthreadpool0.
  * d/rules: use ninja as cmake backend.
  * d/control:
    + bump std-ver to 4.7.2 (no changes required).
    + change homepage to google fork.
    + mark Multi-Arch: same for dev package, use correct section name.

 -- Shengqi Chen <harry@debian.org>  Sat, 25 Oct 2025 16:49:32 +0800
