=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: pthreadpool
-Section: libdevel
-Homepage: https://github.com/Maratyszcza/pthreadpool
+Section: libs
+Homepage: https://github.com/google/pthreadpool
 Priority: optional
-Standards-Version: 4.7.0.1
+Standards-Version: 4.7.2
 Vcs-Git: https://salsa.debian.org/deeplearning-team/pthreadpool.git
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/pthreadpool
 Maintainer: Debian Deep Learning Team <debian-ai@lists.debian.org>
@@ -10,13 +10,16 @@
 Build-Depends: cmake,
                debhelper-compat (= 13),
                googletest,
+               ninja-build,
                libbenchmark-dev,
                libcpuinfo-dev,
                libfxdiv-dev
 Rules-Requires-Root: no
 
 Package: libpthreadpool-dev
+Section: libdevel
 Architecture: any
+Multi-Arch: same
 Depends: libpthreadpool0 (= ${binary:Version}), ${misc:Depends}
 Description: pthread-based thread pool for C/C++ (development)
  pthreadpool is a portable and efficient thread pool implementation. It provides
@@ -26,6 +29,7 @@
  This package contains the development files.
 
 Package: libpthreadpool0
+Section: libs
 Architecture: any
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Multi-Arch: same
