=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ -Scmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DGOOGLETEST_SOURCE_DIR=/usr/src/googletest -DPTHREADPOOL_LIBRARY_TYPE=shared
