=== debian/watch ===
Version: 5
Source: https://github.com/google/pthreadpool
Mode: git
Pgpmode: none
Matching-Pattern: HEAD
